# Toolkit for data management and analysis

Hybra Core is a toolkit to work with data and helps to
* wrangle
* visualize
* analyze
the data.

Hybra Core is part of the [Hybra Data Analysis Ecosystem](http://research.cs.aalto.fi/dcc/output/hybra), supporting also data collection and processing.

# The toolkit

## Documentation

See [http://hybra.readthedocs.io/](http://hybra.readthedocs.io/en/latest/) for documentation and code examples.

## Contents

* core: the actual code for data management and analysis
* test: automated tests for data our library
* data: small example datasets
* docs: documentation

# Acknowledgements

## Background

We thank following funders for supporting this work

* Academy of Finland
   * Racisms and public communications in the hybrid media environment (HYBRA) project uses this tool as its primary computational data analysis environment.
* Kone Foundation
   * Matti Nelimarkka's work on mainstreaming this tool was supported by Digital Humanities of Public Policy Making.
* TEKES - the Finnish Funding Agency for Innovation
   * Smarter Social Media Analytics
* Sanoma Foundation
   * Early work towards this ecosystem was done in Digivaalit 2015 project.

## Authors

* Matti Nelimarkka (matti.nelimarkka@aalto.fi)
* Juho Pääkkönen (juho.paakkonen@aalto.fi)
* Arto Kekkonen (arto.kekkonen@helsinki.fi)

source('topics.r')

library('topicmodels')

print( commandArgs(trailingOnly=TRUE) )

for( path in commandArgs(trailingOnly=TRUE) ) {

  print( paste( path , 'best.rdata', sep ='' )  )

  ## load( paste( path , 'best.rdata', sep ='' ) )
  load( path )
  ls()
  write.csv( topics( model, 1 ), file = paste( path , 'topic_assigments.csv', sep ='' ) )

}

source('topics.r')
##source('stm.r')

args <- commandArgs(trailingOnly = TRUE)

dtm_path <- args[1]

if( ! grepl( '.rdata', dtm_path ) ) {
   dtm_path <- paste( dtm_path, '/dtm.rdata', sep='' )
}

load( dtm_path )

k <- as.integer( args[2] )

model <- create_model( dtm , k )

path <- paste( dtm_path , 'topic-', args[2], '.rdata' , sep = '' )

print( path )

save( model , file = path )

create_dtm <- function( path ) {

  library(tm)
  library(slam)

  a <- Corpus( DirSource( path, encoding = "UTF-8", recursive = T ) )

  stop1 <- scan('stop_generic.txt', what = list(""), sep = '\n' )
  stop2 <- c()
##  stop2 <- scan('stop_digivaalit.txt', what = list(""), sep = '\n' )
  stop <- c( stopwords("finnish") , stop1, stop2 , recursive=T )

  ## bunch of cleanup and transformations
  a <- tm_map(a, removeNumbers )
  a <- tm_map(a, stripWhitespace )
  a <- tm_map(a, removePunctuation )
  a <- tm_map(a, content_transformer(tolower) )
  a <- tm_map(a, removeWords, stop )

  ## compute word frequencies
  dtm1 <-DocumentTermMatrix(a)

  frequency <- col_sums( dtm1 , na.rm = T )
  frequency <- sort(frequency, decreasing=TRUE)

  ## choose removal boundaries for further data analysis

  upper = floor( length( frequency ) * .001 )
  ##upper = Inf
  lower = floor( length( frequency) * .9 )
  
  upper = frequency[ upper ]
  lower = frequency[ lower ]
  
  upper = as.integer( upper )
  lower = as.integer( lower ) + 1

  dtm2 = DocumentTermMatrix( a , control = list( bounds = list( global = c( lower, upper ) ) ) )

  ## throw away columns with 0 indicators
  dtm3 <- dtm2[ row_sums( dtm2 ) > 0, ]

  dtm <- dtm3

  return( dtm )

}

create_model <- function( dtm, k ) {

   library(topicmodels)

   ## fix randomness
   set.seed( 1 )

   burnin = 1000
   iter = 1000
   keep = 50

   model <- LDA( dtm , k = k, method = "Gibbs", control =  list(burnin = burnin, iter = iter, keep = keep) )

   return( model )

}

check_fitness_ll <- function( model ) {

  ## TODO: could we just use logLik-methods?

  library(topicmodels)
  library(Rmpfr)

  burnin = 1000
  iter = 1000
  keep = 50

  ll <- model@logLiks[ -c(1:(burnin/keep)) ]

  precision = 2000L
  llMed <- median( ll )
  ll = as.double( llMed - log( mean( exp( -mpfr(ll , prec = precision) + llMed ) ) ) )

  return( ll )

}


check_fitness_model <- function( model ) {

  library(topicmodels)
  library(Rmpfr)

  burnin = 1000
  iter = 1000
  keep = 50

  k <- model@k

  ll <- model@logLiks[ -c(1:(burnin/keep)) ]

  precision = 2000L
  llMed <- median( ll )
  ll = as.double( llMed - log( mean( exp( -mpfr(ll , prec = precision) + llMed ) ) ) )

  return( ll )

}

## from http://www.r-bloggers.com/a-link-between-topicmodels-lda-and-ldavis/

visualize_topicmodel <- function(fitted, corpus, doc_term){
    # Required packages
    library(topicmodels)
    library(dplyr)
    library(stringi)
    library(tm)
    library(LDAvis)

    # Find required quantities
    phi <- posterior(fitted)$terms %>% as.matrix
    theta <- posterior(fitted)$topics %>% as.matrix
    vocab <- colnames(phi)
    doc_length <- vector()
    for (i in 1:length(corpus)) {
        temp <- paste(corpus[[i]]$content, collapse = ' ')
        doc_length <- c(doc_length, stri_count(temp, regex = '\\S+'))
    }
    temp_frequency <- inspect(doc_term)
    freq_matrix <- data.frame(ST = colnames(temp_frequency),
                              Freq = colSums(temp_frequency))
    rm(temp_frequency)

    # Convert to json
    json_lda <- LDAvis::createJSON(phi = phi, theta = theta,
                            vocab = vocab,
                            doc.length = doc_length,
                            term.frequency = freq_matrix$Freq)

    return(json_lda)
}

library("argparser")

p <- arg_parser("Find the best fit of a topic model thing")

p <- add_argument(p, "folder", help="Folder where files of which DTM is created")
p <- add_argument(p, "--upper", help="Which percentage from the upper frequency of keywords is removed", default = 0.001)
p <- add_argument(p, "--lower", help="Which percentage from the lower frequency of keywords is removed", default = 0.1)
p <- add_argument(p, "--clear", help="Remove all existing .rdata-files", flag=TRUE, default=TRUE)
p <- add_argument(p, "--stopwords", help="Files of stopwords to be removed. Separate files with :", default = 'stop_generic.txt' )

args <- parse_args( p )

source('topics.r')

for( path in args$folder ) {

   print( paste( "Working on" , path ) )

   if( args$clear ) {
     unlink( paste( path , '*.rdata*', sep = '' ) ) ## remove all existing rdata in the folder
   }

   stopwords <- strsplit( args$stopwords, ':' )[[1]]

   print( stopwords )

   dtm <- create_dtm( path, args$upper, args$lower, stopwords )
   save( dtm , file = paste( path, 'dtm.rdata' , sep = '' ) )

}

source('topics.r')

args <- commandArgs(trailingOnly = TRUE)

load( args[1] )
k <- as.integer( args[2] )

model <- create_model( dtm , k )

path <- paste( args[1] , '-', args[2], '.rdata' , sep = '' )
save( model , file = path )

create_model <- function( dtm, k ) {

  library(stm)

  out <- readCorpus( dtm, type = "slam" )

  documents <- out$documents
  vocab <- out$vocab

  topic <- stm(documents, vocab, K = k, init.type = "Spectral", max.em.its = 50)

  return( topic )

}

source('topics.r')

library("argparser")

p <- arg_parser("Find the best fit of a topic model thing")

p <- add_argument(p, "--plot", help="create a plot", flag=TRUE)
p <- add_argument(p, "--method", help="choose method in use", default = "logll")
p <- add_argument(p, "--dtm", help="dtm used" )
p <- add_argument(p, "folder", help="folders to analyse")

args <- parse_args( p )

value_method <- check_fitness_ll; ## default to logll

if( args$method == 'perplexity' ) {

  library('topicmodels')

  ## there should be additional parameter for dtm
  load( '/Users/mnelimar/OneDrive - Aalto-yliopisto/projects/2016-topicmodelkritiikki/dtm_perdocument.rdata' )
  value_method <- function( x ) { perplexity( x, dtm3 ); } ## make similar to logkelihood

}

##for( path in commandArgs(trailingOnly=TRUE) ) {

  df = data.frame( k = integer(), value =integer() )

  path <- args$folder;

  for( f in list.files( path, pattern = 'topic*') ){
        print( f )
  	load( paste(path, f, sep = '') )
  	k <- model@k
    value <- value_method( model )
  	row = c(k, value)
  	df[ nrow(df)+1,] <- row
  }

  print("Examinging")
  print( path )

  print("Best fit k" )
  print( df$k[ which.max( df$value ) ] )

  print("Best fit value")
  print( df$value[ which.max( df$value ) ] )
  print("") ## Empty line

  if( args$plot ) {

    library('ggplot2')

    g <- ggplot( df , aes(k , value ) ) +
    geom_line() +
    xlab('k') + ylab('measure') +
    theme_minimal() +
    xlim(2,250) ## TODO: make args

    ggsave( file = 'plot.pdf' , g)

  }

##}

source('topics.r')

library('topicmodels')

print( commandArgs(trailingOnly=TRUE) )

for( path in commandArgs(trailingOnly=TRUE) ) {

  print( paste( path , 'best.rdata', sep ='' )  )

  load( paste( path , 'best.rdata', sep ='' ) )
  ls()
  write.csv( t( terms( model, 15 ) ), file = paste( path , 'best_terms.csv', sep ='' ) )

}
